import { FormControl, FormControlState } from '@core';

/**
 * @description 搜索表单部件
 * @export
 * @class FormControl
 * @extends {MainControl}
 */
export class SearchFormControl extends FormControl {
  /**
   * @description 部件状态
   * @type {FormControlState}
   * @memberof FormControl
   */
  public declare state: FormControlState;

  /**
   * @description 查询
   * @memberof SearchFormControl
   */
  public onSearch() {
    const { controlName } = this.state;
    this.emit("ctrlEvent", {
      tag: controlName,
      action: "selectionChange",
      data: this.state.data,
    });
  }


  /**
   * @description 取消
   * @memberof SearchFormControl
   */
  public onCancel() {
    //todo 获取部件实列
  }

  /**
   * @description 确认保存
   * @memberof SearchFormControl
   */
  public onOk() {
    //todo saveModel服务
  }

  /**
   * @description 安装部件所有功能模块的方法
   * @return {*}
   * @memberof SearchFormControl
   */
  public moduleInstall() {
    const superParams = super.moduleInstall();
    // 表单行为能力启用
    const { loadDraft } = this.useLoadDraft();
    return {
      ...superParams,
      loadDraft,
      onSearch: this.onSearch.bind(this),
      onCancel: this.onCancel.bind(this),
      onOk: this.onOk.bind(this),
      handleEditorEvent: this.handleEditorEvent.bind(this),
      handleComponentEvent: this.handleComponentEvent.bind(this),
    };
  }
}
